package com.ruoyi.ucp.service.impl;

import cn.hutool.core.date.DateTime;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.support.SFunction;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.annotation.DataSource;
import com.ruoyi.common.enums.DataSourceType;
import com.ruoyi.ucp.entity.TurbineInfoDay;
import com.ruoyi.ucp.mapper.TurbineInfoDayMapper;
import com.ruoyi.ucp.service.ITurbineInfoDayService;
import com.ruoyi.ucp.util.DatePart;
import com.ruoyi.ucp.util.SqlUtil;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author gfhd
 * @since 2024-05-29
 */
@Service
@DataSource(DataSourceType.SLAVE)
public class TurbineInfoDayServiceImpl extends ServiceImpl<TurbineInfoDayMapper, TurbineInfoDay> implements ITurbineInfoDayService {
    @Override
    public List<TurbineInfoDay> list(Wrapper<TurbineInfoDay> queryWrapper) {
        return super.list(queryWrapper);
    }

    //save方法
    @Override
    public boolean save(TurbineInfoDay entity) {
        return super.save(entity);
    }

    //getOne
    @Override
    public TurbineInfoDay getOne(Wrapper<TurbineInfoDay> queryWrapper) {
        return super.getOne(queryWrapper);
    }

    //根据ID更新
    @Override
    public boolean updateById(TurbineInfoDay entity) {
        return super.updateById(entity);
    }

    @Override
    public boolean saveOrUpdateBatch(Collection<TurbineInfoDay> entityList) {
        return super.saveOrUpdateBatch(entityList);
    }

    public List<TurbineInfoDay> getDatasByPartSelects(Date date, DatePart datePart, String selects, String groupIds) {
        DateTime[] beginEnd = SqlUtil.getBeginEnd(date, datePart);
        QueryWrapper<TurbineInfoDay> wrapper = new QueryWrapper<>();
        wrapper.select(selects + groupIds).groupBy(groupIds).between("record_date", beginEnd[0], beginEnd[1]);
        return super.list(wrapper);
    }

    public Map<String, TurbineInfoDay> getDatasByPartSelect(Date date, DatePart datePart, String selects, SFunction<TurbineInfoDay, String> groupId) {
        DateTime[] beginEnd = SqlUtil.getBeginEnd(date, datePart);
        QueryWrapper<TurbineInfoDay> wrapper = new QueryWrapper<>();
        wrapper.select(selects);
        wrapper.lambda().between(TurbineInfoDay::getRecordDate, beginEnd[0], beginEnd[1])
                .select(groupId).groupBy(groupId);
        List<TurbineInfoDay> days = super.list(wrapper);
        return days.stream().collect(Collectors.toMap(groupId, Function.identity()));
    }
}
