package com.ruoyi.ucp.util;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.StandardChartTheme;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

import javax.swing.*;
import java.awt.*;

public class TimeSeriesChart extends JFrame {
    private XYSeriesCollection dataset;

    public TimeSeriesChart(String title, XYSeries... series) {
        super(title);
        // 将XYSeries添加到XYSeriesCollection中
        dataset = new XYSeriesCollection();
        for (XYSeries xySeries : series) {
            dataset.addSeries(xySeries);
        }
        //创建主题样式
        StandardChartTheme standardChartTheme = new StandardChartTheme("CN");
        //设置标题字体
        standardChartTheme.setExtraLargeFont(new Font("隶书", Font.BOLD, 20));
        //设置图例的字体
        standardChartTheme.setRegularFont(new Font("宋书", Font.PLAIN, 15));
        //设置轴向的字体
        standardChartTheme.setLargeFont(new Font("宋书", Font.PLAIN, 15));
        //应用主题样式
        ChartFactory.setChartTheme(standardChartTheme);
        // 创建图表
        JFreeChart chart = ChartFactory.createXYLineChart(
                "功率曲线",
                "时间", // X轴标签
                "功率", // Y轴标签
                dataset,
                PlotOrientation.VERTICAL,
                true, true, true // 显示图例、工具提示、URL生成
        );
        //chart.getTitle().setFont(new Font("微软雅黑", Font.PLAIN, 16));
        //XYPlot plot = chart.getXYPlot();
        //plot.getDomainAxis().setLabelFont(new Font("微软雅黑", Font.PLAIN, 12));
        //plot.getRangeAxis().setLabelFont(new Font("微软雅黑", Font.PLAIN, 12));
        //XYLineAndShapeRenderer renderer = new XYLineAndShapeRenderer();
        //renderer.setSeriesShapesVisible(0, false);
        //plot.setRenderer(renderer);
        //plot.getDomainAxis().setTickLabelFont(new Font("微软雅黑", Font.PLAIN, 10));
        //plot.getRangeAxis().setTickLabelFont(new Font("微软雅黑", Font.PLAIN, 10));
        // 将图表放入面板中
        ChartPanel chartPanel = new ChartPanel(chart);
        chartPanel.setPreferredSize(new Dimension(1920, 900));
        setContentPane(chartPanel);
    }

    public TimeSeriesChart(String title) {
        super(title);
        //创建主题样式
        StandardChartTheme standardChartTheme = new StandardChartTheme("CN");
        //设置标题字体
        standardChartTheme.setExtraLargeFont(new Font("隶书", Font.BOLD, 20));
        //设置图例的字体
        standardChartTheme.setRegularFont(new Font("宋书", Font.PLAIN, 15));
        //设置轴向的字体
        standardChartTheme.setLargeFont(new Font("宋书", Font.PLAIN, 15));
        //应用主题样式
        ChartFactory.setChartTheme(standardChartTheme);
    }

    public void add(XYSeries series) {
        // 将XYSeries添加到XYSeriesCollection中
        if (dataset == null) dataset = new XYSeriesCollection();
        dataset.addSeries(series);
    }
    public void create(){
        // 创建图表
        JFreeChart chart = ChartFactory.createXYLineChart(
                "功率曲线",
                "时间", // X轴标签
                "功率", // Y轴标签
                dataset,
                PlotOrientation.VERTICAL,
                true, true, true // 显示图例、工具提示、URL生成
        );
        // 将图表放入面板中
        ChartPanel chartPanel = new ChartPanel(chart);
        chartPanel.setPreferredSize(new Dimension(1920, 900));
        setContentPane(chartPanel);

        setSize(1920, 900);
        setLocationRelativeTo(null);
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        setVisible(true);
    }
}
